// strng0.cpp -- StringBad class methods
#include <iostream>
#include <cstring>                 // string.h for some
#include "strng0.h"
using namespace std;

// initializing static class member
int StringBad::num_strings = 0;

// class methods
StringBad::StringBad(const char * s)     // construct StringBad from C string
{
    len = strlen(s);               // set size
    str = new char[len + 1];       // allot storage
    strcpy(str, s);                // initialize pointer
    num_strings++;                 // set object count
    cout << num_strings << ": \"" << str
         << "\" object created\n"; // For Your Information
}

StringBad::StringBad()                   // default constructor
{
    len = 4;
    str = new char[4];
    strcpy(str, "C++");            // default string
    num_strings++;
    cout << num_strings << ": \"" << str
         << "\" default object created\n";  // FYI
}

StringBad::StringBad(const StringBad & st)
{
    num_strings++;             // handle static member update
    len = st.len;              // same length
    str = new char [len + 1];  // allot space
    strcpy(str, st.str);       // copy string to new location
    cout << num_strings << ": \"" << str
         << "\" object created\n"; // For Your Information
}

StringBad::~StringBad()                     // necessary destructor
{
    cout << "\"" << str << "\" object deleted, ";    // FYI
    --num_strings;                    // required
    cout << num_strings << " left\n"; // FYI
    delete [] str;                    // required
}

StringBad & StringBad::operator=(const StringBad & st)
{
    if (this == &st)           // object assigned to itself
        return *this;          // all done
    delete [] str;             // free old string
    len = st.len;
    str = new char [len + 1];  // get space for new string
    strcpy(str, st.str);       // copy the string
    return *this;              // return reference to invoking object
}

ostream & operator<<(ostream & os, const StringBad & st)
{
    os << st.str;
    return os; 
}
